﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using jsTree_Core_Razor.Models;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Newtonsoft.Json;

namespace jsTree_Core_Razor.Pages
{
    public class IndexModel : PageModel
    {
        public string TreeViewJSON { get; set; }

        private DBCtx Context { get; }
        public IndexModel(DBCtx _context)
        {
            this.Context = _context;
        }

        public void OnGet()
        {
            List<TreeViewNode> nodes = new List<TreeViewNode>();

            //Loop and add the Parent Nodes.
            foreach (VehicleType type in this.Context.VehicleTypes)
            {
                nodes.Add(new TreeViewNode { id = type.Id.ToString(), parent = "#", text = type.Name });
            }

            //Loop and add the Child Nodes.
            foreach (VehicleSubType subType in this.Context.VehicleSubTypes)
            {
                nodes.Add(new TreeViewNode { id = subType.VehicleTypeId.ToString() + "-" + subType.Id.ToString(), parent = subType.VehicleTypeId.ToString(), text = subType.Name });
            }

            //Serialize to JSON string.
            this.TreeViewJSON = JsonConvert.SerializeObject(nodes);
        }

        public void OnPostSubmit(string selectedItems)
        {
            List<TreeViewNode> items = JsonConvert.DeserializeObject<List<TreeViewNode>>(selectedItems);
        }
    }
}